<?php
session_start();
require_once ("../../config/Cado.php");
require_once ("../producto/cCatalogo.php");
$oCatalogo = new cCatalogo();
require_once("../producto/cProducto.php");
$oProducto = new cProducto();
require_once ("../documento/cDocumento.php");
$oDocumento = new cDocumento();
require_once("../tipocambiotesoreria/cTipocambiotesoreria.php");
$oTipocambiotesoreria = new cTipocambiotesoreria();
require_once ("../preciogestion/cPreciogestion.php");
$oPreciogestion = new cPreciogestion();

require_once("../tipocambio/cTipocambio.php");
$oTipocambio = new ctipocambio();

require_once ("../stock/cStock.php");
$oStock = new cStock();

require_once("../almacen/cAlmacen.php");
$oAlmacen = new cAlmacen();

$fecha = date('Y-m-d');
require_once ("../formatos/formato.php");

function responder($estado=false, $mensaje='', $datos=[])
{
	header('Content-type: application/json');
	echo json_encode([
		'est' => $estado,
		'msj' => $mensaje,
		'dat' => $datos,
	]);
	exit;
}


if($_POST['action']=='agregar')
{
	
		// echo $_POST['cat_preven'];
	
	if($_POST['cat_can']!="")
	{
		
		
		
		$dts1=$oCatalogo->mostrarUno($_POST['cat_id'],$_POST['mar_id']);
		$dt1 = mysqli_fetch_array($dts1);
		
		$emp_fac = $dt1['tb_empaque_fac'];
		$pre_id = $dt1['tb_presentacion_id'];
		$pronom = $dt1['tb_producto_nom'];
		$ran = $dt1['tb_catalogo_ran'];
		//$precos = $dt1['tb_productomarca_precos'];
		//$prevenmen = $dt1['tb_productomarca_preven'];
		//$prevenmenf = $dt1['tb_productomarca_prevenf'];
		$arttip_id = $dt1['tb_articulotipo_id'];
		
		//echo $_POST['cat_preven'].'-';
		
		$dtspre = $oPreciogestion->mostrar_precioxpuntoventa($_POST['cat_id'],$_SESSION['puntoventa_id']);		
					$numrowspre = mysqli_num_rows($dtspre);
					
					$dtp = mysqli_fetch_array($dtspre);
					$prevenmenf = $dtp['tb_precioproducto_prevenf'];
					$prevenmen = $dtp['tb_precioproducto_preven'];
					$precos = $dtp['tb_precioproducto_precom'];
					$preproesp_id = $dtp['tb_precioproducto_id'];
		
		
		$dts1=$oAlmacen->mostrarAlmCajEmp($_SESSION['puntoventa_id']);
			$dt1 = mysqli_fetch_array($dts1);
 			$emp=$dt1['tb_empresa_id'];
 			$punven_id=$dt1['tb_puntoventa_id'];
 			$piso_id=$dt1['tb_piso_id'];
 			$alm = $dt1['tb_almacen_id'];
		mysqli_free_result($dts1);
		
		
		 
		 $rs = $oTipocambio->consultar(fecha_mysql($fecha));  
		 $dt = mysqli_fetch_array($rs);
		 $tipcam = formato_money3($dt['tb_tipocambio_dolsun']);
		
		$rsdoc = $oDocumento->mostrarUno($_POST['doc_id']);  
		$dtdoc = mysqli_fetch_array($rsdoc);
 		$doc_nom = $dtdoc['tb_documento_nom'];
		mysqli_free_result($rsdoc);
		
		//echo $arttip_id.'--'.$doc_nom;
		
		//if( $arttip_id=='3')
		
			
		
		if($arttip_id == 3 &&  $doc_nom != "TICKET" ){
			
			responder(false, 'El PRODUCTO NO SE PUEDE VENDER CON '.$doc_nom, ['tipo' => 'interno']);
			
		}else{
		
		
		$stock = mysqli_fetch_array($oStock->stock_por_presentacion($_POST['cat_id'],$_POST['mar_id'],$alm))['tb_stock_num'];
		
		//echo $can.'--'.$stock;
		
		$_POST['cat_can'] = strtoupper($_POST['cat_can']);
		//echo $_POST['cat_can'];
		
			$can1 = $_POST['cat_can'];
			$pos = strpos($can1, 'F');
			
			if($pos===false){
			
			$can  = $can1 * $emp_fac;
			//$_POST['cat_preven'] = $prevenmen;
			
			if($_POST['cat_preven']!=""){
			
			}else{
				$_POST['cat_preven'] = $prevenmen;
			}
		
			
			}else{
				
				
			if($_POST['cat_preven']!=""){
			
			}else{
				$_POST['cat_preven'] = $prevenmenf;
			}
			
			$cane = 0;
			$canf = 0;
			list($cane,$canf) = explode('F',$can1);
			//echo $cane.'--'.$canf;
			$can2 = 0;
			if($cane>0){
				$can2 = $cane*$emp_fac;
			}
				$can = $can2 + $canf;
				
				if($can==$emp_fac){
					$_POST['cat_preven'] = $prevenmen/$can;
				}
				
			}
		
		//echo $can;
			
			
		if($can>$stock)
		{
			
							$can3 = $stock / $emp_fac;
							$canf = 0;
							$cane = 0;
						
							list($cane,$canf) = explode('.',$can3);

							if($cane>0 && $canf>0){
								$canemp = $cane * $emp_fac;
								$canf = $stock - $canemp;
								$stockmsj = $cane.'F'.$canf;
							}else if($cane>0 && $canf==""){
								$stockmsj = $cane;
							}else if($cane=="" && $canf>0){
								$stockmsj = 'F'.$canf;
							}
							
						
			
			responder(false, 'Stock superado del producto ' , ['tipo' => 'cat_sto', 'stock' => $stock]);
		}else if($stock==0)
		{
			responder(false, 'Sin stock :: '.$stock*1 , ['tipo' => 'cat_sto', 'stock' => $stock]);
		}
		
		
		if($_POST['mon'] == 1){
			$msjmon = ' SOLES';
		}else{
			$msjmon = ' DOLARES';
		}
	
		if($_POST['cat_preven']==""){
		
			if($_POST['mon'] == 2){
				$preuni = $prevenmen/$tipcam;
			}else{
				$preuni = $prevenmen ;
			}
			
			$_SESSION['venta_preven'][$_POST['cat_id'].$_POST['mar_id']]= moneda_mysql($preuni);
		
		}else{
			
			if($can>1){
			
			if($_POST['mon']==2){
				$preuni_ven = $_POST['cat_preven'];
				$precos = $precos/$tipcam;
			}else{
				$preuni_ven = $_POST['cat_preven'];
				$precos = $precos;
			}
			
			
			//echo $preuni_ven;
			
			
			//if(moneda_mysql($preuni_ven)<=moneda_mysql($precos)){
			
		//	responder(false, 'EL PRODUCTO '.$pronom.' NO SE PUEDE VENDER IGUAL O MENOS DE '.formato_money($precos).$msjmon , ['tipo' => 'preven']);
			
		//	}else{
		//		$_SESSION['venta_preven'][$_POST['cat_id'].$_POST['mar_id']]= moneda_mysql($_POST['cat_preven']);	
		//	}
			
			$_SESSION['venta_preven'][$_POST['cat_id'].$_POST['mar_id']]= moneda_mysql($_POST['cat_preven']);	
			
			
			}else{
				$_SESSION['venta_preven'][$_POST['cat_id'].$_POST['mar_id']]= moneda_mysql($_POST['cat_preven']);	
			}
			
			
		}	

	
		$_SESSION['venta_catid'][$_POST['cat_id'].$_POST['mar_id']]= $_POST['cat_id'];
		$_SESSION['venta_marid'][$_POST['cat_id'].$_POST['mar_id']]= $_POST['mar_id'];
		$_SESSION['venta_can'][$_POST['cat_id'].$_POST['mar_id']]= $_POST['cat_can'];
		//$_SESSION['venta_pronom'][$_POST['cat_id'].$_POST['mar_id']]= $_POST['pronom'];
		$_SESSION['venta_pronom'][$_POST['cat_id'].$_POST['mar_id']]= $pronom;
		
		if($_POST['est']==""){
			$est = '1';
		}else{
			$est = $_POST['est'];
		}
		
		
		$_SESSION['venta_est'][$_POST['cat_id'].$_POST['mar_id']]=$est;
		
		if($_POST['cat_des']==""){
			$des = 0;
		}else{
			$des = $_POST['cat_des'];
		}

		$_SESSION['venta_des'][$_POST['cat_id'].$_POST['mar_id']] = moneda_mysql($des);
		
		unset($_SESSION['pre1']);
		unset($_SESSION['pre2']);
		
		responder(true, 'Agregado correctamente.', ['tipo' => 'agregado']);
		}
		
	}
	else
	{
		responder(false, 'Ingrese cantidad.', ['tipo' => 'cat_can']);
	}
	
}


if($_POST['action']=='quitar')
{
	unset($_SESSION['venta_catid'][$_POST['cat_id']]);
	unset($_SESSION['venta_marid'][$_POST['cat_id']]);
	unset($_SESSION['venta_des'][$_POST['cat_id']]);
	unset($_SESSION['venta_can'][$_POST['cat_id']]);
	unset($_SESSION['venta_preven'][$_POST['cat_id']]);
	unset($_SESSION['venta_pronom'][$_POST['cat_id']]);
	
	responder(true, '', ['tipo' => 'foco']);
}


if($_POST['action']=='restablecer')
{
	unset($_SESSION['venta_catid']);
	unset($_SESSION['venta_marid']);
	unset($_SESSION['venta_des']);
	unset($_SESSION['venta_can']);
	unset($_SESSION['venta_preven']);
	unset($_SESSION['venta_pronom']);
	
	responder(true, '');
}

if($_POST['action']=='vaciar')
{
		unset($_SESSION['venta_catid']);
	unset($_SESSION['venta_marid']);
	unset($_SESSION['venta_des']);
	unset($_SESSION['venta_can']);
	unset($_SESSION['venta_preven']);
	unset($_SESSION['venta_pronom']);
	
	
	responder(true, '', ['tipo' => 'foco']);
}

?>